#include "kiss-exception.h"
#include "ctype.h"

KissODeathException::KissODeathException(
   char * server_name,
   char * kiss_code) throw() {

   int i;
   ConditionalNewline();
   description.append("Server \"");
   description.append(server_name);
   description.append("\" sent Kiss-O-Death, code: \"");
   for (i = 0; i < 4; ++i) {
      if (isprint(kiss_code[i])) {
         description.append(1, kiss_code[i]);
      } else {
         description.append(1, '.');
      }
   }
   description.append("\" (0x");
   for (i = 0; i < 4; ++i) {
      Printf("%02x", kiss_code[i] & 0xff);
   }
   description.append(")");
}

KissODeathException::KissODeathException(
   const KissODeathException& rhs) throw() : BaseException(rhs) {
}

KissODeathException&
KissODeathException::operator=(
   const KissODeathException& rhs) throw() {
   BaseException::operator=(rhs);
   return *this;
}

KissODeathException::~KissODeathException() throw() {
   return;
}
