#ifndef log_stuff_h
#define log_stuff_h

class exception;

// Base class does nothing, but it is convenient to make one of these in
// order to not have to check for NULL pointer all the time when logging
// information.
//
class LogStuff {
public:

   LogStuff();

   virtual
   ~LogStuff();

      // Log the string from the exception.
      //
   virtual void
   LogException(exception & ee);

      // Log a constant string.
      //
   virtual void
   LogString(const char * str);

      // Log a printf-like string, formatting arguments.
      //
   virtual void
   LogPrintf(const char * fmt, ...);

      // Return false in this base class. Folks who are about to go to alot
      // of trouble to build some log information might want to check this
      // to see if they have a valid log before they bother.
      //
   virtual bool
   ValidLog();
};

#endif // log_stuff_h
