#ifndef ntp_real_events_h
#define ntp_real_events_h

#include "ntp-events.h"
#include <aclapi.h>

class LogStuff;

// This class overrides all the NtpEvents methods and really does something.
// The service creates one of these classes when the AllowPoke registry key
// is enabled.
//
class NtpRealEvents : public NtpEvents {
public:

   NtpRealEvents(bool is_nt,
                 bool allow_poke,
                 bool allow_monitor,
                 LogStuff * logp);

   virtual
   ~NtpRealEvents();

      // Check this after the constructor to see if everything went OK
      //
   virtual bool
   IsValid();

      // Append the poke_event and (if we created one) the stop_event
      // to the ev array.
      //
   virtual DWORD
   AppendExtraEvents(HANDLE ev[], DWORD evcount);

      // Reset the poke event.
      //
   virtual void
   ResetPoke();

      // Set the "init state" event, reset any other set state.
      //
   virtual void
   SetInitState();

      // Set the "sync OK" event, reset any other set state.
      //
   virtual void
   SetSyncOK();

      // Set the "sync warning" event, reset any other set state.
      //
   virtual void
   SetSyncWarn();

      // Set the "shutting down" event, reset any other set state.
      //
   virtual void
   SetShutdownState();

private:

   HANDLE       poke_event;

   HANDLE       states[4];

   bool         is_valid;

   enum ev_state {
      EV_INIT = 0,
      EV_OK = 1,
      EV_WARN = 2,
      EV_CLOSE = 3,
   };

   ev_state     cur_state;

   void
   CommonStateChange(ev_state set_me);

      // Utility function - try to make Global\name, if that doesn't work,
      // just make name.
      //
   HANDLE
   MakeGlobalEvent(LPSECURITY_ATTRIBUTES sap,
                   BOOL manual_reset,
                   BOOL initial_state,
                   LPCTSTR name);
};

#endif // ntp_real_events_h
