#ifndef wrap_socket_h
#define wrap_socket_h

// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include <windows.h>

// Wrapper class that insures a socket will get closed when it goes out
// of scope.
//
class WrapSocket {
public:

   WrapSocket(SOCKET init_s)
      : s(init_s) {};

   ~WrapSocket()
      { if (s != INVALID_SOCKET) closesocket(s); };

   operator SOCKET () const
      {return s;};

private:

   SOCKET s;
};

#endif // wrap_socket_h
