#ifndef wrap_reg_key_h
#define wrap_reg_key_h

// Copyright (C) Tom Horsley, 2004. All rights reserved.

#include <windows.h>

// WrapRegKey is used to hold a registry HKEY and make sure it gets closed
// when it goes out of scope...
//
class WrapRegKey {
public:

   WrapRegKey(HKEY init_scp)
      : regk(init_scp) {};

   ~WrapRegKey()
      { if (regk != NULL) ::RegCloseKey(regk); };

   operator HKEY () const
      {return regk;};

private:

   HKEY regk;
};

#endif // wrap_reg_key_h
