#ifndef wrap_sc_handle_h
#define wrap_sc_handle_h

// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include <windows.h>

// WrapScHandle is used to hold a SC_HANDLE and make sure it gets closed
// when it goes out of scope...
//
class WrapScHandle {
public:

   WrapScHandle(SC_HANDLE init_scp)
      : scp(init_scp) {};

   ~WrapScHandle()
      { if (scp != NULL) ::CloseServiceHandle(scp); };

   operator SC_HANDLE () const
      {return scp;};

private:

   SC_HANDLE scp;
};

#endif // wrap_sc_handle_h
