/* This file derived from the winerror.h file in the SDK (as near as I can
 * tell, that's the only place you can find these descriptions). Everything
 * is ifdefed since who knows which versions of headers define which errors.
 */

#ifdef WSAEINTR
{WSAEINTR,"A blocking operation was interrupted by a call to WSACancelBlockingCall."},
#endif
#ifdef WSAEBADF
{WSAEBADF,"The file handle supplied is not valid."},
#endif
#ifdef WSAEACCES
{WSAEACCES,"An attempt was made to access a socket in a way forbidden by its access permissions."},
#endif
#ifdef WSAEFAULT
{WSAEFAULT,"The system detected an invalid pointer address in attempting to use a pointer argument in a call."},
#endif
#ifdef WSAEINVAL
{WSAEINVAL,"An invalid argument was supplied."},
#endif
#ifdef WSAEMFILE
{WSAEMFILE,"Too many open sockets."},
#endif
#ifdef WSAEWOULDBLOCK
{WSAEWOULDBLOCK,"A non-blocking socket operation could not be completed immediately."},
#endif
#ifdef WSAEINPROGRESS
{WSAEINPROGRESS,"A blocking operation is currently executing."},
#endif
#ifdef WSAEALREADY
{WSAEALREADY,"An operation was attempted on a non-blocking socket that already had an operation in progress."},
#endif
#ifdef WSAENOTSOCK
{WSAENOTSOCK,"An operation was attempted on something that is not a socket."},
#endif
#ifdef WSAEDESTADDRREQ
{WSAEDESTADDRREQ,"A required address was omitted from an operation on a socket."},
#endif
#ifdef WSAEMSGSIZE
{WSAEMSGSIZE,"A message sent on a datagram socket was larger than the internal message buffer or some other network limit, or the buffer used to receive a datagram into was smaller than the datagram itself."},
#endif
#ifdef WSAEPROTOTYPE
{WSAEPROTOTYPE,"A protocol was specified in the socket function call that does not support the semantics of the socket type requested."},
#endif
#ifdef WSAENOPROTOOPT
{WSAENOPROTOOPT,"An unknown, invalid, or unsupported option or level was specified in a getsockopt or setsockopt call."},
#endif
#ifdef WSAEPROTONOSUPPORT
{WSAEPROTONOSUPPORT,"The requested protocol has not been configured into the system, or no implementation for it exists."},
#endif
#ifdef WSAESOCKTNOSUPPORT
{WSAESOCKTNOSUPPORT,"The support for the specified socket type does not exist in this address family."},
#endif
#ifdef WSAEOPNOTSUPP
{WSAEOPNOTSUPP,"The attempted operation is not supported for the type of object referenced."},
#endif
#ifdef WSAEPFNOSUPPORT
{WSAEPFNOSUPPORT,"The protocol family has not been configured into the system or no implementation for it exists."},
#endif
#ifdef WSAEAFNOSUPPORT
{WSAEAFNOSUPPORT,"An address incompatible with the requested protocol was used."},
#endif
#ifdef WSAEADDRINUSE
{WSAEADDRINUSE,"Only one usage of each socket address (protocol/network address/port) is normally permitted."},
#endif
#ifdef WSAEADDRNOTAVAIL
{WSAEADDRNOTAVAIL,"The requested address is not valid in its context."},
#endif
#ifdef WSAENETDOWN
{WSAENETDOWN,"A socket operation encountered a dead network."},
#endif
#ifdef WSAENETUNREACH
{WSAENETUNREACH,"A socket operation was attempted to an unreachable network."},
#endif
#ifdef WSAENETRESET
{WSAENETRESET,"The connection has been broken due to keep-alive activity detecting a failure while the operation was in progress."},
#endif
#ifdef WSAECONNABORTED
{WSAECONNABORTED,"An established connection was aborted by the software in your host machine."},
#endif
#ifdef WSAECONNRESET
{WSAECONNRESET,"An existing connection was forcibly closed by the remote host."},
#endif
#ifdef WSAENOBUFS
{WSAENOBUFS,"An operation on a socket could not be performed because the system lacked sufficient buffer space or because a queue was full."},
#endif
#ifdef WSAEISCONN
{WSAEISCONN,"A connect request was made on an already connected socket."},
#endif
#ifdef WSAENOTCONN
{WSAENOTCONN,"A request to send or receive data was disallowed because the socket is not connected and (when sending on a datagram socket using a sendto call) no address was supplied."},
#endif
#ifdef WSAESHUTDOWN
{WSAESHUTDOWN,"A request to send or receive data was disallowed because the socket had already been shut down in that direction with a previous shutdown call."},
#endif
#ifdef WSAETOOMANYREFS
{WSAETOOMANYREFS,"Too many references to some kernel object."},
#endif
#ifdef WSAETIMEDOUT
{WSAETIMEDOUT,"A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond."},
#endif
#ifdef WSAECONNREFUSED
{WSAECONNREFUSED,"No connection could be made because the target machine actively refused it."},
#endif
#ifdef WSAELOOP
{WSAELOOP,"Cannot translate name."},
#endif
#ifdef WSAENAMETOOLONG
{WSAENAMETOOLONG,"Name component or name was too long."},
#endif
#ifdef WSAEHOSTDOWN
{WSAEHOSTDOWN,"A socket operation failed because the destination host was down."},
#endif
#ifdef WSAEHOSTUNREACH
{WSAEHOSTUNREACH,"A socket operation was attempted to an unreachable host."},
#endif
#ifdef WSAENOTEMPTY
{WSAENOTEMPTY,"Cannot remove a directory that is not empty."},
#endif
#ifdef WSAEPROCLIM
{WSAEPROCLIM,"A Windows Sockets implementation may have a limit on the number of applications that may use it simultaneously."},
#endif
#ifdef WSAEUSERS
{WSAEUSERS,"Ran out of quota."},
#endif
#ifdef WSAEDQUOT
{WSAEDQUOT,"Ran out of disk quota."},
#endif
#ifdef WSAESTALE
{WSAESTALE,"File handle reference is no longer available."},
#endif
#ifdef WSAEREMOTE
{WSAEREMOTE,"Item is not available locally."},
#endif
#ifdef WSASYSNOTREADY
{WSASYSNOTREADY,"WSAStartup cannot function at this time because the underlying system it uses to provide network services is currently unavailable."},
#endif
#ifdef WSAVERNOTSUPPORTED
{WSAVERNOTSUPPORTED,"The Windows Sockets version requested is not supported."},
#endif
#ifdef WSANOTINITIALISED
{WSANOTINITIALISED,"Either the application has not called WSAStartup, or WSAStartup failed."},
#endif
#ifdef WSAEDISCON
{WSAEDISCON,"Returned by WSARecv or WSARecvFrom to indicate the remote party has initiated a graceful shutdown sequence."},
#endif
#ifdef WSAENOMORE
{WSAENOMORE,"No more results can be returned by WSALookupServiceNext."},
#endif
#ifdef WSAECANCELLED
{WSAECANCELLED,"A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled."},
#endif
#ifdef WSAEINVALIDPROCTABLE
{WSAEINVALIDPROCTABLE,"The procedure call table is invalid."},
#endif
#ifdef WSAEINVALIDPROVIDER
{WSAEINVALIDPROVIDER,"The requested service provider is invalid."},
#endif
#ifdef WSAEPROVIDERFAILEDINIT
{WSAEPROVIDERFAILEDINIT,"The requested service provider could not be loaded or initialized."},
#endif
#ifdef WSASYSCALLFAILURE
{WSASYSCALLFAILURE,"A system call that should never fail has failed."},
#endif
#ifdef WSASERVICE_NOT_FOUND
{WSASERVICE_NOT_FOUND,"No such service is known. The service cannot be found in the specified name space."},
#endif
#ifdef WSATYPE_NOT_FOUND
{WSATYPE_NOT_FOUND,"The specified class was not found."},
#endif
#ifdef WSA_E_NO_MORE
{WSA_E_NO_MORE,"No more results can be returned by WSALookupServiceNext."},
#endif
#ifdef WSA_E_CANCELLED
{WSA_E_CANCELLED,"A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled."},
#endif
#ifdef WSAEREFUSED
{WSAEREFUSED,"A database query failed because it was actively refused."},
#endif
#ifdef WSAHOST_NOT_FOUND
{WSAHOST_NOT_FOUND,"No such host is known."},
#endif
#ifdef WSATRY_AGAIN
{WSATRY_AGAIN,"This is usually a temporary error during hostname resolution and means that the local server did not receive a response from an authoritative server."},
#endif
#ifdef WSANO_RECOVERY
{WSANO_RECOVERY,"A non-recoverable error occurred during a database lookup."},
#endif
#ifdef WSANO_DATA
{WSANO_DATA,"The requested name is valid and was found in the database, but it does not have the correct associated data being resolved for."},
#endif
#ifdef WSA_QOS_RECEIVERS
{WSA_QOS_RECEIVERS,"At least one reserve has arrived."},
#endif
#ifdef WSA_QOS_SENDERS
{WSA_QOS_SENDERS,"At least one path has arrived."},
#endif
#ifdef WSA_QOS_NO_SENDERS
{WSA_QOS_NO_SENDERS,"There are no senders."},
#endif
#ifdef WSA_QOS_NO_RECEIVERS
{WSA_QOS_NO_RECEIVERS,"There are no receivers."},
#endif
#ifdef WSA_QOS_REQUEST_CONFIRMED
{WSA_QOS_REQUEST_CONFIRMED,"Reserve has been confirmed."},
#endif
#ifdef WSA_QOS_ADMISSION_FAILURE
{WSA_QOS_ADMISSION_FAILURE,"Error due to lack of resources."},
#endif
#ifdef WSA_QOS_POLICY_FAILURE
{WSA_QOS_POLICY_FAILURE,"Rejected for administrative reasons - bad credentials."},
#endif
#ifdef WSA_QOS_BAD_STYLE
{WSA_QOS_BAD_STYLE,"Unknown or conflicting style."},
#endif
#ifdef WSA_QOS_BAD_OBJECT
{WSA_QOS_BAD_OBJECT,"Problem with some part of the filterspec or providerspecific buffer in general."},
#endif
#ifdef WSA_QOS_TRAFFIC_CTRL_ERROR
{WSA_QOS_TRAFFIC_CTRL_ERROR,"Problem with some part of the flowspec."},
#endif
#ifdef WSA_QOS_GENERIC_ERROR
{WSA_QOS_GENERIC_ERROR,"General QOS error."},
#endif
#ifdef WSA_QOS_ESERVICETYPE
{WSA_QOS_ESERVICETYPE,"An invalid or unrecognized service type was found in the flowspec."},
#endif
#ifdef WSA_QOS_EFLOWSPEC
{WSA_QOS_EFLOWSPEC,"An invalid or inconsistent flowspec was found in the QOS structure."},
#endif
#ifdef WSA_QOS_EPROVSPECBUF
{WSA_QOS_EPROVSPECBUF,"Invalid QOS provider-specific buffer."},
#endif
#ifdef WSA_QOS_EFILTERSTYLE
{WSA_QOS_EFILTERSTYLE,"An invalid QOS filter style was used."},
#endif
#ifdef WSA_QOS_EFILTERTYPE
{WSA_QOS_EFILTERTYPE,"An invalid QOS filter type was used."},
#endif
#ifdef WSA_QOS_EFILTERCOUNT
{WSA_QOS_EFILTERCOUNT,"An incorrect number of QOS FILTERSPECs were specified in the FLOWDESCRIPTOR."},
#endif
#ifdef WSA_QOS_EOBJLENGTH
{WSA_QOS_EOBJLENGTH,"An object with an invalid ObjectLength field was specified in the QOS provider-specific buffer."},
#endif
#ifdef WSA_QOS_EFLOWCOUNT
{WSA_QOS_EFLOWCOUNT,"An incorrect number of flow descriptors was specified in the QOS structure."},
#endif
#ifdef WSA_QOS_EUNKOWNPSOBJ
{WSA_QOS_EUNKOWNPSOBJ,"An unrecognized object was found in the QOS provider-specific buffer."},
#endif
#ifdef WSA_QOS_EPOLICYOBJ
{WSA_QOS_EPOLICYOBJ,"An invalid policy object was found in the QOS provider-specific buffer."},
#endif
#ifdef WSA_QOS_EFLOWDESC
{WSA_QOS_EFLOWDESC,"An invalid QOS flow descriptor was found in the flow descriptor list."},
#endif
#ifdef WSA_QOS_EPSFLOWSPEC
{WSA_QOS_EPSFLOWSPEC,"An invalid or inconsistent flowspec was found in the QOS provider specific buffer."},
#endif
#ifdef WSA_QOS_EPSFILTERSPEC
{WSA_QOS_EPSFILTERSPEC,"An invalid FILTERSPEC was found in the QOS provider-specific buffer."},
#endif
#ifdef WSA_QOS_ESDMODEOBJ
{WSA_QOS_ESDMODEOBJ,"An invalid shape discard mode object was found in the QOS provider specific buffer."},
#endif
#ifdef WSA_QOS_ESHAPERATEOBJ
{WSA_QOS_ESHAPERATEOBJ,"An invalid shaping rate object was found in the QOS provider-specific buffer."},
#endif
#ifdef WSA_QOS_RESERVED_PETYPE
{WSA_QOS_RESERVED_PETYPE,"A reserved policy element was found in the QOS provider-specific buffer."},
#endif
